{$A+,B-,D-,E+,F-,G+,I-,L-,N-,O-,R-,S-,V+,X-}
{$M 8129,0,3000}
Program DrvWatch;

uses Dos,scrhndl,aspi (* ,EditLn,misctool; *);

 type ArrayOfChar = Array [1..MaxInt] of char;
      ArrayOfCharPtr = ^ArrayOfChar;

Const
         IntToUse     = $13;
         MaxDrive     = 1;


Type     String4 = String [4];
         String2 = String [2];
         Str80   = String [80];
         Str15   = String [15];
         Str64   = String [64];


Var
         DiskBios,
         VidBios    : Byte;
         InDosByte  : Byte;
         MakeInt    : Byte;
         IntProgAdr : Pointer;

         OldPSP     : Word;
         InUse      : Boolean;
         ShowTime   : Boolean;

         Time       : Array [0..MaxDrive] of Word; (* Zaehler fr die Zeit *)
         Action     : Array [0..MaxDrive] of Byte; (* 1: Start Request, 2: Stop Request *)
         IsSleeping : Array [0..MaxDrive] of Boolean;
         Request    : boolean;
         i          : byte;
         Sleeptime  : word;
         Temp       : word;
         Err        : integer;



{$F+}
{$L INTHELP.OBJ}

procedure Install(IntToUse:Word;IntToInstall:Pointer);  external;

{##$S-}
Function  Hex       (Zahl : Word):String4 ;
Var      A,Z  : Word;
         I    : Word;
         S1   : String4;
Begin
S1 := '';
For A:=1 To 4 Do
  Begin
    Z := Zahl And 15;
    If Z > 9 Then Z := Z + 7;
    S1 := Chr(Z+48)+S1;
    Zahl := Zahl shr 4; {div 16 }
  End;
  Hex := S1;
End;
{##$S+}

{##$S-}
Function  HexB      (Zahl : Word):String2 ;
Var      A,Z  : Word;
         I    : Word;
         S1   : String4;
Begin
S1 := '';
For A:=1 To 2 Do
  Begin
    Z := Zahl And 15;
    If Z > 9 Then Z := Z + 7;
    S1 := Chr(Z+48)+S1;
    Zahl := Zahl shr 4; {div 16 }
  End;
  HexB := S1;
End;
{##$S+}

{##$S-}
Procedure SetPascalPSP;
var r      : Registers;
begin
      If (InDosByte=0) then
         begin
              r.ah:=$62;  (* Adresse des Aktiven PSP erfragen*)
              MsDos(r);
              OldPSP:=r.bx;
              r.ah:=$50;
              r.bx:=PrefixSeg;  (* Adresse des Turbo PSP setzen
                                   damit der zugriff auf die datei erfolgen kann *)
              MsDos(r);
          end;
end;
{##$S+}

{##$S-}
Procedure SetOldPSP;
var r      : Registers;
begin
          If (InDosByte=0) then
             begin
                 r.ah:=$50;
                 r.bx:=OldPSP;
                 MsDos(r);
end;         end;
{##$S+}

Function AnAus(b:boolean):string4;
begin
 if b then AnAus:='An'
      else AnAus:='Aus';
end;

Procedure DoRequest;
var
(* i: byte;*)
    Drive: byte;
begin
  Drive := 99;
{
  writeln('Processing Request');
}
  for i:=0 to MaxDrive do
       begin
{          writeln(' ',Action[i]); }
          if Action[i]<>0 then  Drive:=i;
       end;
  if Drive <=1 then
    begin
      if Action[Drive] = 1  then
                begin (* Start *)
                  if IsSleeping[Drive] then
                    begin
                      Time[Drive]:=0;
                      SCSIStartStop(0 , Drive , 0 , 1  , 0 );
                      IsSleeping[Drive] := false;
                    end;
                 Action[Drive]:=0;
                 end;

      if Action[Drive] = 2 then
               begin (* Stop *)
                  if not IsSleeping[Drive] then
                    begin
{                      writeln('Stopping Drive '+Chr(Ord('0')+Drive));}
                      Time[Drive]:=0;
                      SCSIStartStop(0 , Drive , 0 , 0  , 0 );
                      IsSleeping[Drive] := true;
                    end;
                  Action[Drive]:=0;
               end;
    end;
  Request := False;
end;

Procedure Show(x:Word);
var temp : String[10];
begin
   Str(x:6,temp);
   temp := temp +'s';
   for i:=1 to length(temp) do Mem[$b800:80+i*2]:=ord(temp[i]);
end;

Procedure TimerProc;
begin
  Inc(Time[0]);
  Inc(Time[1]);
  if (time[0] mod 18 = 10) then (* ca jede Sekunde updaten *)
                  begin
                     mem[$b800:158]:=$20;
                     if not IsSleeping[0] then
                        begin
                          Show( Round((SleepTime-Time[0]) / 18.2 ));
                        end;
                  end;
  if Time[0]>Sleeptime then
                           begin
                             Action[0]:=2 ; (* Stop Drive *)
                             Request:=True;
                             Time[0]:=0;
                           end
  else (* nicht zwei auf einmal *)
  if Time[1]>Sleeptime then
                           begin
                             Action[1]:=2 ; (* Stop Drive *)
                             Request:=True;
                             Time[1]:=0;
                           end;
 If Request then
 If InUse then
 If (IndosByte=0) then
 begin
    inline($fa); (* CLI *)
    SetPascalPSP;
    DoRequest;
    SetOldPSP;
    inline($fb); (* STI *)
 end;
end (* TimerProc *);

Procedure DosFreiProc;
begin
 If Request then
 If InUse then
  begin
    SetPascalPSP;
      DoRequest;
    SetOldPSP;
  end;
end (* DosFrei *);


Procedure Interpret (var CS,IP:Word;var Regs:Registers);
var Drive: byte;
Begin
 With Regs do begin
      IF (AH>=0) and (AH<=18) THEN
        begin
          case dl of
            $80,$81: begin
                      Drive := dl -$80;
                      MEM[$b800:158]:=ORD('0')+Drive;
                      if isSleeping[Drive] then
                          begin
                             SCSIStartStop(0 , Drive , 0 , 1  , 0 );
                             IsSleeping[Drive]:=false;
                          end
                        else
                          begin
                            Time[Drive]:=0;  (* Reset Timer *)
                          end;
                   end;
          end (* case *);
        end;
 End (* With *);
End (* Interpret *);

{##$S+}

(*********************************************************************)
(*********************************************************************)
Procedure Aktivate;

const LastWahl: byte = 1;

var GrafikMode: Boolean;
    Vmode     : Byte;
    OldX,OldY : Byte;
    Wahl      : Byte;
    Ch        : Char;
Begin
 SetPascalPSP;
{ OldX:=whereX;
 OldY:=WhereY;}
 If (Videomode<>0) and (Videomode<>1) and (Videomode<>2) and
    (Videomode<>3) and (Videomode<>7) then
      begin
        VMode:=VideoMode and $7f;
        PushScreen;
        SetVideoMode($83);
        MakeWindow(1,1,79,25,2,Double);
        GrafikMode:=True;
      end
     else GrafikMode:=False;
  repeat
      Wahl:=BigMenu(Remove,4,LastWahl,
                'Diskwatch Ver 1.0', '      bwerwachung     : '+AnAus(InUse)+'\'+
                                     'Toggle Drive 0 Zustand : '+AnAus(not IsSleeping[0])+'\'+
                                     'Toggle Drive 1 Zustand : '+AnAus(not IsSleeping[1])+'\'+
                                     'TimeOut Anzeigen       : '+AnAus(ShowTime)+'\',
                                     'Schaltet das Programm ein oder aus\'+
                                     'Ein/Ausschalten von Drive 0\'+
                                     'Ein/Ausschalten von Drive 1\' +
                                     'Zeigt den TimeOut an\');
      If Wahl<>0 then LastWahl:=Wahl;
      Case Wahl of
        1:  If not InUse then
               begin
(*                 Sound (5000);
                 Delay (500);
                 NoSound;
*)
                 InUse := True;
               end
            else
               begin
(*                  Sound (500);
                  Delay (500);
                  NoSound;
*)
                  InUse := False;
               end;
        2:     begin
                 if IsSleeping[0] then
                                      Action[0]:=1
                                  else
                                      Action[0]:=2;
                 Request:=true;
               end;
        3:     begin
                 if IsSleeping[1] then
                                      Action[1]:=1
                                  else
                                      Action[1]:=2;
                 Request:=true;
               end;
       end (* Case  *);
  until (Wahl=0) or (Wahl=1) or (wahl=2) or (Wahl=3);
  If GrafikMode then   (* GrafikBildschirm wiederherstellen  *)
      begin
        RemoveLastWindow;
(*        TextMode(Lastmode);*)
        SetVideoMode(Vmode or $80);
        PopScreen;
      end;
  RestoreCursorPos;
{  Gotoxy(OldX,OldY);}
  SetOldPSP;
end;


Procedure InAktivate;
Begin
end;

{##$S-}
(*********************************************************************)
(*********************************************************************)
Var Regs:Registers;
PROCEDURE IntProg(RetFlags,RetCS,RetIP,DummyFlags,DummyCS,DummyIP,RAX,RBX,RCX,RDX,RSI,RDI,RDS,RES,RBP:WORD);
interrupt;
begin
   SetPascalPSP;
{   mem [$B800:0000] := 88; }
   Regs.AX:=RAX;              (*  Achtung SP sowie SS sind Nicht die vom *)
   Regs.BX:=RBX;              (*  aufrufenden PRG sondern vom Inthandler *)
   Regs.CX:=RCX;              (*  und werden dort auch wieder auf ihr    *)
   Regs.DX:=RDX;              (*  Orginal gesetzt                        *)
   Regs.BP:=RBP;              (*  Alle Anderen sind die Register mit     *)
   Regs.SI:=RSI;              (*  denen der Int21 aufgerufen wurde,      *)
   Regs.DI:=RDI;              (*  sie sind soz. als Var declariert       *)
   Regs.DS:=RDS;              (*  so das eine Vernderung sich auf das   *)
   Regs.ES:=RES;              (*  rufende PRG auswirkt                   *)
   Regs.Flags:=RetFlags;
   MakeInt:=1;            (* lasse Int21h vom Assemblerprg ausfhren *)

   Interpret (RetCS,RetIP,Regs);

   RAX:=Regs.AX;
   RBX:=Regs.BX;
   RCX:=Regs.CX;
   RDX:=Regs.DX;
   RBP:=Regs.BP;
   RSI:=Regs.SI;
   RDI:=Regs.DI;
   RDS:=Regs.DS;
   RES:=Regs.ES;
   RetFlags   :=Regs.Flags;
   DummyFlags :=Regs.Flags;
   SetOldPSP;
end;
{$F-}
{##$S+}


begin
  InUse     := True;
  Request   := False;
  ShowTime  := True;
  For i:=0 to MaxDrive do
    begin
      time[i]:=0;
      Action[i]:=0;
      IsSleeping[i]:=false;
    end;
  SleepTime := Round(18.2 * 60 * 5) (* Standard: 5 Minuten *);
  if Paramcount > 0 then
       begin
         val(ParamStr(1),Temp,Err);
         if Err=0 then SleepTime := Round(18.2 * 60 * Temp);
       end;
  AspiInit;

  Writeln('Diskwatch Ver 1.0 installiert ',SleepTime);
  Writeln('Press Control Left-Shift Alt at the same Time to start');
  Writeln;
  Install(IntToUse,@Intprog);
  Keep(0);
end.
